precision highp float;

uniform sampler2D inputImageTexture;
uniform lowp sampler2D inputImageTexture2; //u_colorShadowsHighlightsSampler
uniform lowp sampler2D inputImageTexture3; //u_threeChannelColorMapSampler
uniform lowp mat4 u_colorMatrix;

varying highp vec2 textureCoordinate;

void main(void) {
    highp vec4 color = texture2D(inputImageTexture, textureCoordinate);

	color.r = texture2D(inputImageTexture2, vec2(0.0, color.r)).r;
	color.g = texture2D(inputImageTexture2, vec2(0.0, color.g)).r;
	color.b = texture2D(inputImageTexture2, vec2(0.0, color.b)).r;

	float intensity = 0.3 * color.r + 0.59 * color.g + 0.11 * color.b;

	float shDiff = texture2D(inputImageTexture2, vec2(0.0, intensity)).g - intensity;

	color.rgb += shDiff;

	color.rgb = clamp(color.rgb, 0.0, 1.0);

	vec4 colorMatrixRGB = vec4(color.rgb, 1.0);

	colorMatrixRGB = colorMatrixRGB * u_colorMatrix;

	colorMatrixRGB = clamp(colorMatrixRGB, 0.0, 1.0);

	colorMatrixRGB.r = texture2D(inputImageTexture3, vec2(0.0, colorMatrixRGB.r)).r;
	colorMatrixRGB.g = texture2D(inputImageTexture3, vec2(0.0, colorMatrixRGB.g)).g;
	colorMatrixRGB.b = texture2D(inputImageTexture3, vec2(0.0, colorMatrixRGB.b)).b;

	gl_FragColor = vec4(colorMatrixRGB.rgb * color.a, color.a);
}
