precision highp float;

uniform sampler2D inputImageTexture;

varying highp vec2 textureCoordinate;

varying highp vec2 v_texCoordMinus1;
varying highp vec2 v_texCoordPlus1;
varying highp vec2 v_texCoordMinus2;
varying highp vec2 v_texCoordPlus2;
varying highp vec2 v_texCoordMinus3;
varying highp vec2 v_texCoordPlus3;
varying highp vec2 v_texCoordMinus4;
varying highp vec2 v_texCoordPlus4;

uniform highp float u_weight0;
uniform highp float u_weight1;
uniform highp float u_weight2;
uniform highp float u_weight3;
uniform highp float u_weight4;

void main(void) {

    highp vec4 resultColor = texture2D(inputImageTexture, textureCoordinate) * u_weight0;
    resultColor += texture2D(inputImageTexture, v_texCoordPlus1) * u_weight1;
    resultColor += texture2D(inputImageTexture, v_texCoordMinus1) * u_weight1;
    resultColor += texture2D(inputImageTexture, v_texCoordPlus2) * u_weight2;
    resultColor += texture2D(inputImageTexture, v_texCoordMinus2) * u_weight2;
    resultColor += texture2D(inputImageTexture, v_texCoordPlus3) * u_weight3;
    resultColor += texture2D(inputImageTexture, v_texCoordMinus3) * u_weight3;
    resultColor += texture2D(inputImageTexture, v_texCoordPlus4) * u_weight4;
    resultColor += texture2D(inputImageTexture, v_texCoordMinus4) * u_weight4;

    gl_FragColor = resultColor / (u_weight0 + 2.0 * (u_weight1 + u_weight2 + u_weight3 + u_weight4));

    //gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
}
