precision lowp float;

varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform vec3 filterColor;


void main()
{
    lowp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    
    //lowp vec4 inputColor = (textureColor + 0.5) * 0.5;
    lowp vec4 inputColor = textureColor;
    
    
    gl_FragColor = vec4(
                    (inputColor.r < 0.5 ? (2.0 * inputColor.r * filterColor.r) : (1.0 - 2.0 * (1.0 - inputColor.r) * (1.0 - filterColor.r))),
                    (inputColor.g < 0.5 ? (2.0 * inputColor.g * filterColor.g) : (1.0 - 2.0 * (1.0 - inputColor.g) * (1.0 - filterColor.g))),
                    (inputColor.b < 0.5 ? (2.0 * inputColor.b * filterColor.b) : (1.0 - 2.0 * (1.0 - inputColor.b) * (1.0 - filterColor.b))),
                    textureColor.a
                    );
}
